"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const enums_1 = require("@rxstack/platform/dist/enums");
const _ = require("lodash");
const utils_1 = require("./utils");
exports.associateWithCurrentUser = (options) => {
    return (event) => __awaiter(void 0, void 0, void 0, function* () {
        utils_1.restrictToOperations(event.eventType, [enums_1.OperationEventsEnum.PRE_EXECUTE]);
        const token = event.request.token;
        utils_1.assertToken(token);
        options = _.merge({ idField: 'id', targetField: 'userId' }, options);
        const userId = utils_1.getProperty(token.getUser(), options.idField);
        _.isArray(event.request.body) ?
            _.forEach(event.request.body, (item) => _.set(item, options.targetField, userId)) :
            _.set(event.request.body, options.targetField, userId);
    });
};
//# sourceMappingURL=associate-with-current-user.js.map