"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const platform_1 = require("@rxstack/platform");
const query_filter_1 = require("@rxstack/query-filter");
const _ = require("lodash");
const utils_1 = require("./utils");
const exceptions_1 = require("@rxstack/exceptions");
exports.queryFilter = (schema) => {
    return (event) => __awaiter(void 0, void 0, void 0, function* () {
        utils_1.restrictToOperations(event.eventType, [platform_1.OperationEventsEnum.PRE_EXECUTE]);
        if (!event.request.attributes.has('query')) {
            throw new exceptions_1.MethodNotAllowedException('Query does not exist.');
        }
        const query = query_filter_1.queryFilter.createQuery(schema, event.request.params.toObject());
        _.merge(event.request.attributes.get('query'), query);
    });
};
//# sourceMappingURL=query-filter.js.map