"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const platform_1 = require("@rxstack/platform");
const exceptions_1 = require("@rxstack/exceptions");
const _ = require("lodash");
const utils_1 = require("./utils");
exports.restrictToOwner = (options) => {
    return (event) => __awaiter(void 0, void 0, void 0, function* () {
        utils_1.restrictToOperations(event.eventType, [platform_1.OperationEventsEnum.PRE_EXECUTE]);
        const token = event.request.token;
        utils_1.assertToken(token);
        options = _.merge({ idField: 'id', targetField: 'userId' }, options);
        const userProp = utils_1.getProperty(token.getUser(), options.idField);
        const data = event.getData();
        _.isArray(data) ? data.forEach((v) => checkData(v, userProp, options.targetField)) :
            checkData(data, userProp, options.targetField);
    });
};
const checkData = (data, userProp, targetField) => {
    const targetId = _.get(data, targetField);
    if (userProp !== targetId) {
        throw new exceptions_1.ForbiddenException();
    }
};
//# sourceMappingURL=restrict-to-owner.js.map